; Do not change filenames or add or remove FILEI/FILEO statements using an editor. Use Cube/Application Manager.
RUN PGM=NETWORK PRNFILE="C:\BOMDLS\BO-30B\2030 NET-FFSPD\NTNET00B.PRN" MSG='Compute FFSPD values and adjusted SPD1 Values'
FILEO PRINTO[1] = "{Working Folder-FFSPD}\TRNSPEEDS.PRN"
FILEI LOOKUPI[2] = "{Working Folder-FFSPD}\TSPDS.CSV"
FILEI LOOKUPI[1] = "{Working Folder-FFSPD}\SEGMENT.CSV"
FILEI LINKI[1] = "{Working Folder-FFSPD}\TMPNET2.NET"
FILEO NETO = "{Working Folder-FFSPD}\UNLOADED_BASE.NET",
 EXCLUDE=FFSPD,POSTSPD,FFOLD,SPD1


;==================
  if (time>0)
    _AUTOSPEED=60*DISTANCE/TIME
  else
    _AUTOSPEED=15
  ENDIF

  LOOKUP name=curve,
     lookup[1]=1, result=16,
     lookup[2]=2, result=17,
     lookup[3]=3, result=18,
     lookup[4]=4, result=19,
     lookup[5]=5, result=20,
     lookup[6]=6, result=21,
     lookup[7]=7, result=22,
     lookup[8]=8, result=23,
     lookup[9]=9, result=24,
     lookup[10]=10, result=25,
     lookup[11]=11, result=26,
     lookup[12]=12, result=27,
     lookup[13]=13, result=28,
     lookup[14]=14, result=29,
     lookup[15]=15, result=30,
     interpolate=y, list=y, lookupi=2

read,
 FILE = "C:\BOMDLS\BO-30B\2030 NET-FFSPD\CURVES.TXT"

     ; APPLY DEFAULT CURVES
     IF (_AUTOSPEED>0) 
       _TSPD1=CURVE(_CURVEMODE1,_AUTOSPEED)
       _TSPD4=CURVE(_CURVEMODE4,_AUTOSPEED)
       _TSPD5=CURVE(_CURVEMODE5,_AUTOSPEED)
       _TSPD6=CURVE(_CURVEMODE6,_AUTOSPEED)
       _TSPD8=CURVE(_CURVEMODE8,_AUTOSPEED)
       _TSPD12=CURVE(_CURVEMODE12,_AUTOSPEED)

       LBTIME=60*DISTANCE/_TSPD4
       EBTIME=60*DISTANCE/_TSPD6
       RLTIME=60*DISTANCE/_TSPD8
       SHTIME=60*DISTANCE/_TSPD12

     ENDIF
     ; OVERRIDES FROM NETWORK AND YET MISSING VALUES
     IF (TTIME>0&TMODE= 4) LBTIME=TTIME
     IF (TTIME>0&TMODE= 6) EBTIME=TTIME
     IF (TTIME>0&TMODE= 8) RLTIME=TTIME
     IF (TTIME>0&TMODE=12) SHTIME=TTIME
     IF (LBTIME=0) LBTIME=99
     IF (EBTIME=0) EBTIME=99
     IF (SHTIME=0) SHTIME=99
     _WKSPEED=60*DISTANCE/LBTIME
     _LBSPEED=60*DISTANCE/LBTIME
     _EBSPEED=60*DISTANCE/EBTIME
     _RLSPEED=60*DISTANCE/RLTIME
     _SHSPEED=60*DISTANCE/SHTIME

; WALK CONTROLS
     WALKSPEED=CURVE(_CURVEMODE1,2.5)
     WALKTIME=60*DISTANCE/WALKSPEED
     IF (FACILITY_TYPE=10-19,70-99)
        WALKDISTANCE=9.99
        WALKTIME=9.99
     ENDIF

PRINT LIST="A=",A(4.0)," B=",B(4.0),
           "  SPEEDS-  Auto=",_AUTOSPEED(4.1),
           " Walk=",WALKSPEED(4.1),
           " Local Bus=",_LBSPEED(4.1),
           " Express Bus=",_EBSPEED(4.1),
           " Shuttle Bus=",_SHSPEED(4.1),
           " Rail=",_RLSPEED(4.1),
                            PRINTO=1





;==================
;SEGID LENGTH NUMSIG FT1 CYCLE GC DF DD
; lookup parameters by SEGID
  LOOKUP  LOOKUPI=1 LIST=Y NAME=SEGDATA,
          LOOKUP[1]=1, RESULT=2,  ; SEG LENGTH
          LOOKUP[2]=1, RESULT=3,  ; NUMSIG
          LOOKUP[3]=1, RESULT=4,  ; FT1
          LOOKUP[4]=1, RESULT=5,  ; CYCLE
          LOOKUP[5]=1, RESULT=6,  ; GC
          LOOKUP[6]=1, RESULT=7,  ; DF
          LOOKUP[7]=1, RESULT=8,  ; DD
          INTERPOLATE =N

_slen=SEGDATA(1,SEGID) ; lookup slen from curve 1 for the current link SEGID
_nsig=SEGDATA(2,SEGID) ; lookup nsig from curve 2 for the current link SEGID
_DD=SEGDATA(7,SEGID)   ; lookup DD from curve 7 for the current link SEGID
_secphr=1.0/3600

_FT1=INT(0.1*FACILITY_TYPE) ; Compute FT1 from FT2, note FT1 is already on this input network

IF (_FT1 <> 5)
  IF (li.1.POSTSPD > 50.0)
    FFSPD=0.88*POSTSPD + 14
  ELSE
    FFSPD=0.79*POSTSPD + 12
  ENDIF
  FFOLD=FFSPD
  IF (li.1.SEGID <> 0)
    FFSPD=_slen/( (_slen/FFSPD) + _nsig*_DD*_secphr)
    IF (FFSPD=0)
      _ecount=_ecount+1
      PRINT LIST='FFSPD computed = ',FFSPD
      PRINT LIST='FFOLD= ',FFOLD
      PRINT LIST='SEGID= ',SEGID
      PRINT LIST='slen= ',_slen
      PRINT LIST='nsig= ',_nsig
      PRINT LIST='DD= ',_DD
      PRINT LIST='secphr= ',_secphr
    ENDIF
    _icount=_icount+1
  ELSE
    _ffcount=_ffcount+1
  ENDIF
ELSE
  FFSPD=POSTSPD
ENDIF

; Apply adjustment factors and convert to Integer speeds for use in FSUTMS

_ADJF=1.0

READ,
 FILE = "C:\BOMDLS\BO-30B\2030 NET-FFSPD\MERGE1.DAT"

IF (li.1.POSTSPD <> 0)
  IF (STCARD='S') SPD1=round(100*FFSPD*_ADJF)/100
ENDIF


POSTEDSPEED=POSTSPD

IF (LI.1.POSTSPD<>0)
  FREEFLOWSPEED=SPD1
ELSE
  FREEFLOWSPEED=FFSPD
ENDIF

IF (POSTSPD>0) POSTEDTIME=60*DISTANCE/POSTSPD
IF (FREEFLOWSPEED>0) FREEFLOWTIME=60*DISTANCE/FREEFLOWSPEED
IF (FREEFLOWTIME>0) TIME=FREEFLOWTIME, time2=FREEFLOWTIME
if ({rndnettime}=1) TIME=ROUND(100*TIME)/100 , time2=ROUND(100*TIME2)/100
IF (FACILITY_TYPE=99) TIME=0 TIME2=0

PROCESS  PHASE=SUMMARY 

IF (_ecount>0) PRINT LIST=_ecount,' links with segids were assigned speed=0'

PRINT LIST=_ffcount,' Free-flow links'
PRINT LIST=_icount,' intersection controlled links'

ENDPHASE

  
ENDRUN
